#include <tbox/tbox.h>


static tb_void_t test_run(tb_cpointer_t priv)
{
    tb_socket_ref_t sock_fd;
    tb_ipaddr_t addr, peer_addr;
    tb_size_t ret;

    (void)priv;     
    sock_fd = tb_socket_init(TB_SOCKET_TYPE_UDP, TB_IPADDR_FAMILY_IPV4);
    tb_socket_ctrl(sock_fd, TB_SOCKET_CTRL_SET_BLOCK, tb_false);
    tb_socket_ctrl(sock_fd, TB_SOCKET_CTRL_SET_SEND_BUFF_SIZE, 4 * 1024 * 1024);
    tb_socket_ctrl(sock_fd, TB_SOCKET_CTRL_SET_RECV_BUFF_SIZE, 4 * 1024 * 1024);


    tb_ipaddr_set(&addr, tb_null, 666, (tb_uint8_t)(TB_IPADDR_FAMILY_IPV4));
  
    ret = tb_socket_bind(sock_fd, &addr);

    if (ret != tb_true)
        return;

    while(1){
        tb_byte_t buf[2048];
        ret = tb_socket_urecv(sock_fd, &peer_addr, buf, 2048);

        if (ret > 0){
            tb_printf("recv data len = %d\n", ret);
        }else {
            tb_printf("wait socket urecv \n");
            ret = tb_socket_wait(sock_fd, TB_SOCKET_EVENT_RECV, 1000);
            tb_printf("wait socket urecv done\n");

        }


        
    }
}


int main(int ac, char *av[])
{
    tb_co_scheduler_ref_t scheduler;

    if (!tb_init(tb_null, tb_null)) return -1;

    (void)ac;
    (void)av;
    scheduler = tb_co_scheduler_init();
    if (!scheduler){
        tb_printf("tb_co_scheduler_init failed !\n");
        return -1;
    }

    tb_coroutine_start(scheduler, test_run, NULL, 0);      


    // run scheduler
    tb_co_scheduler_loop(scheduler, tb_true);

    
    // exit scheduler
    tb_co_scheduler_exit(scheduler);

    return 0;
}
