add_requires("tbox", {configs = {debug = false, coroutine=true}})
add_requires("openssl")

-- project
set_project("testudp")

-- set project version
set_version("1.0.0", {build = "%Y%m%d%H%M"})
-- set warning all as error
set_warnings("all", "error")

set_languages("c99")
set_optimize("fastest")

-- disable some compiler errors
add_cxflags("-Wno-error=deprecated-declarations", "-fno-strict-aliasing", "-Wno-error=expansion-to-defined", "-Wall", "-Wextra", "-Werror", "-g")
add_mxflags("-Wno-error=deprecated-declarations", "-fno-strict-aliasing", "-Wno-error=expansion-to-defined")

-- add build modes
add_rules("mode.debug", "mode.release") 

-- add target 

target("test_udp")
	-- deps project
	
	
    -- make as a static library
    set_kind("binary")

    set_warnings("all", "error")

    set_languages("c99", "c++11")
    set_optimize("fastest")


    -- add the common source files
    add_files("*.c")

    -- add depends packages
    add_packages("tbox", "openssl")





